#ifndef curve_h
#define curve_h

#include "natural.h"

class curve {
  mpz_class p; // modulus, must be prime
  natural A; // curve y^2 = x^3 + Ax^2 + x

public:
  mpz_class parent(void) const { return p; }
  natural montgomeryA(void) const { return A; }
  curve(mpz_class p) : p(p), A(0,0) {
  }
  curve(mpz_class p,natural A) : p(p), A(A) {
  }
} ;

#endif
