#include <iostream>
using namespace std;
#include "elligator.h"

#define H 10000
int smallfactor[H];

int main()
{
  for (int i = 2;i < H;++i)
    if (!smallfactor[i])
      for (int j = i + i;j < H;j += i)
        if (!smallfactor[j])
          smallfactor[j] = i;

  for (int pint = 3;pint + 1 < H;pint += 8) {
    if (smallfactor[pint]) continue;
    std::vector<mpz_class> factors;
    int j = pint + 1;
    while (smallfactor[j]) {
      factors.push_back(smallfactor[j]);
      j /= smallfactor[j];
    }
    factors.push_back(j);
    mpz_class p = pint;
    cout << p << ' ' << elligator_base(p,factors) << '\n';
  }

  return 0;
}
