for p in primes(10000):
  if p % 8 != 3: continue

  k = GF(p)
  E = EllipticCurve(k,[1,0])

  for x in range(1,p):
    x = k(x)
    if E.is_x_coord(x):
      y = sqrt(x^3+x)
      u = (p+1)//E(x,y).order()
      if u.is_power_of(2):
        print p,x
        break
